#include "Cjt_estudiants.hh"
#include "solution.hh"
#include <algorithm>

bool nota_decr(const Estudiant& a, const Estudiant& b) {
  /* Pre: cert */
  /* Post: el resultat es cert si la nota d'a es mes gran que la de b
     o, si son iguals, si el dni d'a es mes petit que el de b */
  double nota_a = -1; double nota_b = -1;
  if (a.te_nota()) nota_a = a.consultar_nota();
  if (b.te_nota()) nota_b = b.consultar_nota();
  return (nota_a > nota_b) or
    (nota_a == nota_b and a.consultar_DNI() < b.consultar_DNI());
}

void escriure_nota_decr(const Cjt_estudiants& c) {
  /* Pre: cert */
  /* Post: s'han escrit pel canal estndar de sortida els estudiants
     de c en ordre descendent de nota i, en cas d'empat, en ordre
     ascendent per DNI */
 
  vector<Estudiant> v(c.mida());
  for (int i = 1; i <= c.mida(); ++i) {
    v[i-1] = c.consultar_iessim(i);
  }
  sort(v.begin(), v.end(), nota_decr);
  for (int i = 0; i < v.size(); ++i) {
    v[i].escriure();
  }
}
