#include "Cjt_estudiants.hh"
#include "solution.hh"

void extreure_reavaluables(const Cjt_estudiants& c1, const Cjt_estudiants& c2,
                           double x, double y, double z, Cjt_estudiants& reava)
  /* Pre: c1 i c2 contenen els mateixos estudiants, reava es buit,
          0<=x,y,z<=Estudiant::nota_maxima(), x<=y */
  /* Post: el conjunt reava est format pels estudiants reavaluables de c1 i c2 
           respecte a x,y,z, tots sense nota */
{ 
  for (int i = 1; i <= c1.mida(); ++i) {
    Estudiant e1(c1.consultar_iessim(i)); // tambien vale con una asignacion
    Estudiant e2(c2.consultar_iessim(i));
    if (e1.te_nota() and e2.te_nota()){
      double n1 = e1.consultar_nota();
      double n2 = e2.consultar_nota();
      if (x<=n1 and n1<=y and z<=n2) {
	bool b;
	Estudiant e(e1.consultar_DNI());
	reava.afegir_estudiant(e,b);
      }
    }
  }
}
